////////////////////////////////////////////////////////////////////////////
// NoteCase notes manager project <http://notecase.sf.net>
//
// This code is licensed under BSD license.See "license.txt" for more details.
//
// File: Implements layer for actual reading/writing data into the file
////////////////////////////////////////////////////////////////////////////

#include "IOLayerFile64.h"
#include "debug.h"

IOLayerFile64::IOLayerFile64()
{
}

IOLayerFile64::~IOLayerFile64()
{
}

int IOLayerFile64::Process(char *szBuffer, int nLen)
{
	int nBytes = 0;

	if(MODE_WRITE == m_nMode)
	{
		nBytes = m_file.Write(szBuffer, nLen);
		TRACE("IOLayerFile64::Write (content size=%d)\n", nLen);
	}
	else
	{
		nBytes = m_file.Read(szBuffer, nLen);
		TRACE("IOLayerFile64::Read  (buffer size=%d, read bytes=%d)\n", nLen, nBytes);
	}

	m_nProcessedInBytes += nLen;
	m_nProcessedOutBytes += nBytes;

	//store output size for this operation
	m_nLastOutBytes = nBytes;

	//call next layer attached?
	if(NULL != m_pNextLayer && nBytes > 0)
		return m_pNextLayer->Process(szBuffer, nBytes);

	return nBytes;	
}

int IOLayerFile64::Finalize()
{
	TRACE("IOLayerFile64::Finalize (pass forward)\n");

	//call next layer attached?
	if(NULL != m_pNextLayer)
		return m_pNextLayer->Finalize();
	return 0;
}

